package com.gyee.alarm.mapper.auto;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gyee.alarm.model.auto.ProEconAlarmRule;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gyee.alarm.model.vo.AlarmRuleVo;
import com.gyee.common.model.Alertrule2;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

/**
 * <p>
 * 自定义报警配置 Mapper 接口
 * </p>
 *
 * @author shilin
 * @since 2023-08-09
 */
public interface ProEconAlarmRuleMapper extends BaseMapper<ProEconAlarmRule> {


    @Update({"<script>",
            "update pro_econ_alarm_rule a",
            "<set>",
            "<if test='name != null'>a.name = #{name},</if>",
            "<if test='description != null'>a.description = #{description},</if>",
            "<if test='expression != null'>a.expression = #{expression},</if>",
            "<if test='tag != null'>a.tag = #{tag},</if>",
            "<if test='rank != null'>a.rank = #{rank},</if>",
            "<if test='enable != null'>a.enable = #{enable},</if>",
            "<if test='modelId != null'>a.model_id = #{modelId},</if>",
            "<if test='category != null'>a.category = #{category},</if>",
            "<if test='range != null'>a.range = #{range},</if>",
            "<if test='stationId != null'>a.station_id = #{stationId},</if>",
            "<if test='deviceId != null'>a.device_id = #{deviceId},</if>",
            "<if test='lineId != null'>a.line_id = #{lineId},</if>",
            "<if test='projectId != null'>a.project_id = #{projectId},</if>",
            "<if test='electricalId != null'>a.electrical_id = #{electricalId},</if>",
            "<if test='relatedParts != null'>a.related_parts = #{relatedParts},</if>",
            "<if test='createtime != null'>a.create_time = #{createtime}</if>",
            "</set>",
            "where a.id = #{id}",

            "</script>"})
    Integer updateByAlertruleId(@Param("alertrule") ProEconAlarmRule alertrule);

    @Select({"<script>",
            "select a.* from pro_econ_alarm_rule a",
            "<where>",
            "a.station like '%${station}%'",

            "<if test='name !=null and name !='''>",
            "and a.name like '%${name}%'",
            "</if>",
            "<if test='modelId !=null and modelId !='''>",
            "and a.model_id like '%${modelId}%'",
            "</if>",
            "<if test='rank !=null and rank !='''>",
            "and a.rank = #{rank}",
            "</if>",
            "<if test='category !=null and category !='''>",
            "and a.category = #{category}",
            "</if>",
            "<if test='enabled !=null and enabled !='''>",
            "and a.enable = #{enable}",
            "</if>",
            "<if test='relatedparts !=null and relatedparts !='''>",
            "and a.related_parts = #{relatedparts}",
            "</if>",
            "</where>",

            "</script>"})
    IPage<ProEconAlarmRule> pageQueryAll(Page page,
                                   @Param("name") String name,
                                   @Param("station") String station,
                                   @Param("modelId")String modelId,
                                   @Param("rank")String rank,
                                   @Param("category")String category,
                                   @Param("enable") String enable,
                                   @Param("relatedparts")String relatedparts);

    @Select("select distinct a.related_parts as relatedParts,a.name as alarmName,d.name  as typeName from pro_econ_alarm_rule a"+
            "left join pro_econ_alarm_type d on d.nem_code = a.related_parts"+
            "where related_parts is not null")
    List<AlarmRuleVo> queryTree();

    @Select(" select a.name from  pro_econ_alarm_rule a where a.related_parts = #{relatedParts}   group by a.name ")
    List<ProEconAlarmRule> quertByrelatedParts(@Param("relatedParts") String relatedParts);
    @Select({"<script>",
            "select a.* from pro_econ_alarm_rule a",
            "<where>",
            "a.station like '%${station}%'",
            "<if test='modelId !=null and modelId !='''>",
            "and a.model_id like '%${modelId}%'",
            "</if>",

            "</where>",

            "</script>"})
    List<ProEconAlarmRule> getAllByStationIdAndModelId(@Param("station") String station,
                                                       @Param("modelId") String modelId
    );


    @Select({"<script>",
            "select a.* from pro_econ_alarm_rule a",
            "<where>",
            "a.station like '%${station}%'",

            "<if test='name !=null and name !='''>",
            "and a.name like '%${name}%'",
            "</if>",
            "<if test='modelid !=null and modelid !='''>",
            "and a.model_id like '%${modelid}%'",
            "</if>",
            "</where>",

            "</script>"})
     List<ProEconAlarmRule> getUniformCodeByNameAndStation(@Param("name")String name, @Param("station")String station, @Param("modelid")String modelid);
}
